 /*
 +---------------------------------------------------------------------------+
 | Facebook Microsoft Vista Sidebar Gadget                                   |
 +---------------------------------------------------------------------------+
 | Copyright (c) 2007 Facebook, Inc.                                         |
 | All rights reserved.                                                      |
 |                                                                           |
 | Redistribution and use in source and binary forms, with or without        |
 | modification, are permitted provided that the following conditions        |
 | are met:                                                                  |
 |                                                                           |
 | 1. Redistributions of source code must retain the above copyright         |
 |    notice, this list of conditions and the following disclaimer.          |
 | 2. Redistributions in binary form must reproduce the above copyright      |
 |    notice, this list of conditions and the following disclaimer in the    |
 |    documentation and/or other materials provided with the distribution.   |
 |                                                                           |
 | THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR      |
 | IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES |
 | OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.   |
 | IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,          |
 | INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT  |
 | NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, |
 | DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY     |
 | THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT       |
 | (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF  |
 | THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.         |
 +---------------------------------------------------------------------------+
 | Developer: Amine Nebri - facebook id anebri@yahoo.com                     |
 +---------------------------------------------------------------------------+
*/

var GadgetSetting =
{
    DebugLevel: "info", // possible values are info and debug
    ApiKey: "dd0deed30879717208bd767d58fc6a32",
    Secret: "d826bebac8959eacffc2ea34822ec572",
    ApiFormat: "JSON",
    ApiVersion: "1.0",
    BaseUrl: "https://api.facebook.com/restserver.php",
    AuthenticationTokenUrl: "http://www.facebook.com/code_gen.php",
    PingUrl: "http://www.facebook.com",
    AuthenticationTokenLength: 6,
    MaximumPhotoUploadCount: 720,
    MaximumPhotoCount: 1200,
    MaximumPhotoFileSizeInBytes: 4718592, //4.5MB
    MaximumErrorResponseLength: 2000,
    ValidUploadableImageTypes: [{"name":"JPEG", "type":"JPEG Image", "mimeType":"image/jpeg"}, {"name":"GIF", "type":"GIF Image", "mimeType":"image/gif"}, {"name":"PNG", "type":"PNG Image", "mimeType":"image/png"}],
    Boundary: "irbenenima",
    MillisecondsBeforeRetry: 4000,
    MillisecondsBeforeRetryLimit: 11000,
    AlphanumericRegex: /^([a-zA-Z0-9]+)$/,
    PhotoProperties: "src_big, link, caption",
    Messages: [
                    {"code":"InvalidImageTypeError", "message":"The following files are not supported (only .jpg, .png, .gif)"}
                   ,{"code":"ImageTooBigError", "message":"The following files are too large (limit 4.5MB)"}
                   ,{"code":"UserCancellationError", "message":"Upload process canceled"}
                   ,{"code":"InvalidCodeError", "message":"Invalid Code"}
                   ,{"code":"CodeRequiredError", "message":"Code is required"}
                   ,{"code":"NoResponseRecievedDuringPhotoUploadError", "message":"Facebook is unable to process image"}
                   ,{"code":"FileUploadLimitError", "message":"You cannot upload more than 720 photos"}
                   ,{"code":"FileUploadErrorsFlyoutLinkText", "message":"View upload errors"}
                   ,{"code":"WecomeText", "message":{
                   			"docked":"Click link below to get login code",
                   			"undocked":"Login to the Facebook gadget by getting a one-time login code from the link below."
                   		}
                   	}
                  ],
    PhotoOptions: [
			{"name":"PhotosOfMe","fql":"select @photo.properties from photo where pid in (select pid from photo_tag where subject=@user.id)"}, 
			{"name":"PhotosFromMyAlbums","fql":"select @photo.properties from photo where aid in (select aid from album where owner = @user.id)"},
			{"name":"PhotosFromMeAndMyFriendsAlbums","fql":"select @photo.properties from photo where aid in (select aid from album where (owner in (select uid2 from friend where uid1 =@user.id) or owner=@user.id) AND modified > now() - 3600*336)"},
			{"name":"PhotosFromMyFriendsAlbums","fql":"select @photo.properties from photo where aid in (select aid from album where owner in (select uid2 from friend where uid1=@user.id ) AND modified > now() - 3600*336)"}
                  ]
};