 /*
 +---------------------------------------------------------------------------+
 | Facebook Microsoft Vista Sidebar Gadget                                   |
 +---------------------------------------------------------------------------+
 | Copyright (c) 2007 Facebook, Inc.                                         |
 | All rights reserved.                                                      |
 |                                                                           |
 | Redistribution and use in source and binary forms, with or without        |
 | modification, are permitted provided that the following conditions        |
 | are met:                                                                  |
 |                                                                           |
 | 1. Redistributions of source code must retain the above copyright         |
 |    notice, this list of conditions and the following disclaimer.          |
 | 2. Redistributions in binary form must reproduce the above copyright      |
 |    notice, this list of conditions and the following disclaimer in the    |
 |    documentation and/or other materials provided with the distribution.   |
 |                                                                           |
 | THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR      |
 | IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES |
 | OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.   |
 | IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,          |
 | INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT  |
 | NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, |
 | DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY     |
 | THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT       |
 | (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF  |
 | THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.         |
 +---------------------------------------------------------------------------+
 | Developer: Daniel Ruspini - facebook id dan@ruspini.com                   |
 +---------------------------------------------------------------------------+
*/

/*
 * Flyout is the function literal controlling gadget flyout pane.
 */
Flyout = new function() {

	this.errors;

	this.show = function() {
		if (!System.Gadget.Flyout.show && this.errors.length > 0) {
			System.Gadget.Flyout.file = "upload.html";
			System.Gadget.Flyout.show = true;
		}
	}
	
	this.hide = function() {
		System.Gadget.Flyout.show = false;
	}
	
	this.addErrors = function() {
		if(System.Gadget.Flyout.show) {
		
			var errorHTML = "";
			for (var i=0; i<this.errors.length; i++) {
				errorHTML += "<strong>" + this.errors[i].error + "</strong><ul>";
				
				for (var j=0; j<this.errors[i].files.length; j++) {
					errorHTML += "<li>" + this.errors[i].files[j].name + "</li>";
				}
				errorHTML += "</ul>";
			}
			System.Gadget.Flyout.document.getElementById("upload-errors-node").innerHTML = errorHTML;
		
			if (this.errors.length > 0) {
				System.Gadget.Flyout.document.getElementById("upload-errors").style.display="";
			} else {
				System.Gadget.Flyout.document.getElementById("upload-errors").style.display="none";
			}
		}
	}
	
	this.clearErrors = function() {
		this.errors = new Array();
	}
	
}

System.Gadget.Flyout.onShow = function() {
    Flyout.addErrors();
}
