 /*
 +---------------------------------------------------------------------------+
 | Facebook Microsoft Vista Sidebar Gadget                                   |
 +---------------------------------------------------------------------------+
 | Copyright (c) 2007 Facebook, Inc.                                         |
 | All rights reserved.                                                      |
 |                                                                           |
 | Redistribution and use in source and binary forms, with or without        |
 | modification, are permitted provided that the following conditions        |
 | are met:                                                                  |
 |                                                                           |
 | 1. Redistributions of source code must retain the above copyright         |
 |    notice, this list of conditions and the following disclaimer.          |
 | 2. Redistributions in binary form must reproduce the above copyright      |
 |    notice, this list of conditions and the following disclaimer in the    |
 |    documentation and/or other materials provided with the distribution.   |
 |                                                                           |
 | THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR      |
 | IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES |
 | OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.   |
 | IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,          |
 | INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT  |
 | NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, |
 | DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY     |
 | THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT       |
 | (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF  |
 | THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.         |
 +---------------------------------------------------------------------------+
 | Developer: Daniel Ruspini - facebook id dan@ruspini.com                   |
 +---------------------------------------------------------------------------+
*/

/*
 * Settings is the function literal controlling gadget Settings pane.
 */
Settings = new function() {
	
	this.gadgetViewed = false;										// default
	this.slideshowImageStore = "typeMeAndFriendsAlbums";			// default
	this.slideshowDelay = 10000;									// default
	this.slideshowTransition = "DXImageTransform.Microsoft.Fade";	// default
	this.slideshowCropPhotos = true;								// default
	this.showPokeAlert = true;										// default
	
	
	this.initialize = function() {
		System.Gadget.Settings.write("gadgetLoggedOut", true);
		
		if (System.Gadget.Settings.read("gadgetViewed") != "") {
			this.loadSettings();
		} else {
			this.gadgetViewed = true;
			
			System.Gadget.Settings.write("gadgetViewed", this.gadgetViewed);
			this.writeSettings();	// put defaults into System.Gadget.Settings
		}
	}
	
	this.loadSettings = function() {
		this.slideshowImageStore = System.Gadget.Settings.read("slideshowImageStore");
		this.slideshowDelay = parseInt(System.Gadget.Settings.read("slideshowDelay"));
		this.slideshowTransition = System.Gadget.Settings.read("slideshowTransition");
		this.slideshowCropPhotos = System.Gadget.Settings.read("slideshowCropPhotos");
		this.showPokeAlert = System.Gadget.Settings.read("showPokeAlert");
	}
	
	this.writeSettings = function() {
		System.Gadget.Settings.write("slideshowImageStore", this.slideshowImageStore);
		System.Gadget.Settings.write("slideshowDelay", this.slideshowDelay);
		System.Gadget.Settings.write("slideshowTransition", this.slideshowTransition);
		System.Gadget.Settings.write("slideshowCropPhotos", this.slideshowCropPhotos);
		System.Gadget.Settings.write("showPokeAlert", this.showPokeAlert);
	}

}