'+---------------------------------------------------------------------------+
'| Facebook Microsoft Vista Sidebar Gadget                                   |
'+---------------------------------------------------------------------------+
'| Copyright (c) 2007 Facebook, Inc.                                         |
'| All rights reserved.                                                      |
'|                                                                           |
'| Redistribution and use in source and binary forms, with or without        |
'| modification, are permitted provided that the following conditions        |
'| are met:                                                                  |
'|                                                                           |
'| 1. Redistributions of source code must retain the above copyright         |
'|    notice, this list of conditions and the following disclaimer.          |
'| 2. Redistributions in binary form must reproduce the above copyright      |
'|    notice, this list of conditions and the following disclaimer in the    |
'|    documentation and/or other materials provided with the distribution.   |
'|                                                                           |
'| THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR      |
'| IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES |
'| OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.   |
'| IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,          |
'| INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT  |
'| NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, |
'| DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY     |
'| THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT       |
'| (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF  |
'| THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.         |
'+---------------------------------------------------------------------------+
'| Developer: Amine Nebri - facebook id anebri@yahoo.com                     |
'+---------------------------------------------------------------------------+

' Uses AJAX to upload a binary file to facebook
' This VBScript function makes calls to JavaScript functions
Function uploadBinaryFile(url, stream, filename, fileContentType) 
    Dim response: Set response = AjaxUtil.createAjaxResponse(url)
    Dim data: data = createMultipartFormData(stream, filename, "file_data", fileContentType)
    Dim request: Set request = CreateObject("Microsoft.XMLHTTP")
    
    request.open "POST", url, False
    request.setRequestHeader "Content-type", "multipart/form-data, boundary=" & GadgetSetting.boundary
    request.setRequestHeader "X-Requested-With", "XMLHttpRequest"
    request.setRequestHeader "Connection", "close"
    request.setRequestHeader "Content-length", LenB(data)
    
    Util.log("uploadBinaryFile(VBS): sending data length=" & LenB(data) & " bytes filename=" & filename)
    
    request.send data
    
    response.length = Len(request.responseText)
    response.responseContent = request.responseText
    response.status = request.status
    response.readyState = request.readyState
    
    Util.log("uploadBinaryFile(VBS): Data sent HTTP Status=" & response.status & " readyState=" & response.readyState & " responseLength=" & response.length & " bytes")
    Util.debug("uploadBinaryFile(VBS): HTTP responseText=->" & response.responseContent & "<-")
    
    Set uploadBinaryFile = response
End Function

' Generateds a mutlipart form to be used in the http call
' for uploading an image to facebook
Function createMultipartFormData(stream, filename, fieldName, fileContentType)
    Dim header: header = "--" + GadgetSetting.boundary + vbCrLf + "Content-Disposition: form-data; name=""" + fieldName + """; filename=""" + filename + """" + vbCrLf + "Content-Type: " + fileContentType + vbCrLf + "Content-Transfer-Encoding: binary" + vbCrLf + vbCrLf 
    Dim trailer: trailer = vbCrLf + "--" + GadgetSetting.boundary + "--" + vbCrLf
    Dim recordSet: Set recordSet = CreateObject("ADODB.Recordset")

    recordSet.Fields.Append "data", 205, Len(header) + stream.Size + Len(trailer)
    recordSet.Open
    recordSet.AddNew

    Dim length: length = Len(header)
    
    recordSet("data").AppendChunk(textToBinary(header))
    header = recordSet("data").GetChunk(length)
    recordSet("data") = ""

    length = Len(trailer)
    recordSet("data").AppendChunk(textToBinary(trailer))
    trailer = recordSet("data").GetChunk(length)
    recordSet("data") = ""

    recordSet("data").AppendChunk(header)
    recordSet("data").AppendChunk(stream.Read)
    recordSet("data").AppendChunk(trailer)
 
    recordSet.Update
    
    Dim result: result = recordSet("data")
    
    recordSet.Close
    
    createMultipartFormData = result
End Function

' Convert an ASCII string to binary
Function textToBinary(str)
    Dim i
    Dim result

    For i = 1 To Len(str)
        result = result & ChrB(Asc(Mid(str, i, 1)))
    Next
    textToBinary = result & ChrB(0)
End Function